<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { computed, toRef, ref } from 'vue';
const props = defineProps<{
    modelValue: string,
    label?: string,
    placeholder?:string
    errorText?: string,
    type: string,
    icon?: string,
    required?: boolean,
    size?: string,
    autofocus?:boolean,
    autocomplete?:string,
    id?:string,
    readonly?:boolean,
    max?: string,
    iconRight?: string,
    maxLength?: number,
    iconRightMethod?: ()=>void
}>();

const modelValue = toRef(props, 'modelValue');

const emits = defineEmits<{
    (e: 'update:modelValue', value: string): void
}>();

const localValue = computed({
    get: ()=> modelValue.value,
    set: (value)=> emits(`update:modelValue`, value)
});

const unfreezeInput = (e:any)=>{
    e.target.value = e.target.value;
};

</script>
<template>
    <div class="mb-2 w-full px-0.5">
        <label class="select-none" v-if="label">{{label}}</label>
        <div class="flex flex-row w-full outline outline-1 outline-gray-300 h-8 rounded-md focus-within:outline-accent1-default"  :class="[{'outline-red-700 text-red-700 focus-within:outline-red-900 bg-red-500/50': errorText },{'bg-gray-100/50 text-gray-400 pointer-events-none focus-within:outline-gray-300 focus:outline-gray-300 focus-visible:outline-gray-300':readonly},{'text-gray-500 bg-white': !readonly&&!errorText}]">
            <div class="px-2 pointer-events-none select-none" v-if="icon"><i  :class="`ri-${icon}-line`" class="ri-1x items-center justify-center leading-8"></i></div>
            <input :id="id" class="px-2 grow h-8 focus:ring-0 focus-visible:outline focus-visible:outline-0 bg-transparent text-ellipsis placeholder:text-gray-400 border-r-md placeholder:select-none" :class="[size]"  :type="type" v-model="localValue" :placeholder="placeholder" :required="required" :autofocus="autofocus" :autocomplete="autocomplete" :readonly="readonly" :max="max" :maxlength="maxLength" @click="unfreezeInput">
            <div class="px-2 select-none" :class="{'pointer-events-none':!iconRightMethod}" v-if="iconRight" @click="iconRightMethod"><div :class="{'hover:cursor-pointer hover:text-black': iconRightMethod}"><i :class="`ri-${iconRight}-line`" class="ri-1x items-center justify-center leading-8"></i></div></div>
        </div>
        <span class="text-red-700 w-80" v-if="errorText" v-html="errorText"></span>
    </div>
</template>